/*
 * LICENCE[[
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1/CeCILL 2.O 
 *
 * The contents of this file are subject to the Mozilla Public License Version 
 * 1.1 (the "License"); you may not use this file except in compliance with 
 * the License. You may obtain a copy of the License at http://www.mozilla.org/MPL/ 
 * 
 * Software distributed under the License is distributed on an "AS IS" basis, 
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License 
 * for the specific language governing rights and limitations under the 
 * License. 
 * 
 * The Original Code is utc.fr code. 
 * 
 * The Initial Developer of the Original Code is 
 * Universite de Technologie de Compiegne. 
 * 
 * Portions created by the Initial Developer are Copyright (C) 2005 
 * the Initial Developer. All Rights Reserved. 
 * 
 * Contributor(s): 
 * 
 * 
 * Alternatively, the contents of this file may be used under the terms of 
 * either of the GNU General Public License Version 2 or later (the "GPL"), 
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"), 
 * or the CeCILL Licence Version 2.0 (http://www.cecill.info/licences.en.html), 
 * in which case the provisions of the GPL, the LGPL or the CeCILL are applicable 
 * instead of those above. If you wish to allow use of your version of this file 
 * only under the terms of either the GPL or the LGPL, and not to allow others 
 * to use your version of this file under the terms of the MPL, indicate your 
 * decision by deleting the provisions above and replace them with the notice 
 * and other provisions required by the GPL or the LGPL. If you do not delete 
 * the provisions above, a recipient may use your version of this file under 
 * the terms of any one of the MPL, the GPL, the LGPL or the CeCILL.
 * ]]LICENCE
 */
// components
const SCSESSIONSMGR 	= "@scenari.com/scSessionsMgr;1";
const SCSESSION 		= "@scenari.com/scSession;1";

// interfaces
const nsCI              			= Components.interfaces;
const nsIWebNavigation   			= nsCI.nsIWebNavigation;
const scISessionsMgr 	 			= nsCI.scISessionsMgr;
const scISession 	 				= nsCI.scISession;

// configuration
const cstBridgteBrowserUrl	= "chrome://scenariplayercdrom/content/deskplayer/bridgeBrowser.xhtml";

//preferences
const prefScPStrorage 	=	"scenari.player.storage.path";
const prefScPModule 	=	"scplayer.module.default";

var fBranch = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch(null);

var deskplayer = {
	_contentBrowser : null,
	_currentSession : null,
	_currentSessionUrl : null,
	_sessionsMgr : null,
};

/** Initialisations */
deskplayer.initDesk = function(){
	try{
		//On traite les menus osDependant
		if(ut.isMac){
			var vListElementsToMask = document.getElementsByAttribute("maskInMac", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;
		}else if(ut.isUnix){
			var vListElementsToMask = document.getElementsByAttribute("maskInLin", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;
		}else{
			var vListElementsToMask = document.getElementsByAttribute("maskInWin", "true");
			for(var ii=0; ii<vListElementsToMask.length;ii++) vListElementsToMask[ii].hidden=true;
		}
		
		// initialisations
		this._contentBrowser = document.getElementById("content");
		browserMgr.init(this._contentBrowser);
		this._sessionsMgr = Components.classes[SCSESSIONSMGR].getService(scISessionsMgr);
				
		var vStorageUrl = fBranch.getPrefType(prefScPStrorage)==32 ? fBranch.getCharPref(prefScPStrorage): null;
		if(this._sessionsMgr.canChangeStoragePath(vStorageUrl)==0){// Lieu de stockage prcdemment paramtr tjs OK
			this._sessionsMgr.init(vStorageUrl);
		}else if(this._sessionsMgr.canChangeStoragePath(null)==0){// Lieu de stockage prcdemment paramtr pas OK
			ut.alert("Le lieu de stockage spcifi est inaxessible.\nLe Chemin par dfaut sera utilis.");
			if(fBranch.prefHasUserValue(prefScPStrorage)) fBranch.clearUserPref(prefScPStrorage);
			this._sessionsMgr.init(null);
		}else{
			ut.alert("Aucun espace de stockage n'est valide.\nVeuillez spcifier un espace de stockage valide.");
			this.showConf();
		}
		
		// chargement du module passe en commandLineHandler
		var vModuleUrl = this.xResolveModuleUrl();
		if(vModuleUrl){
			this.loadSession(vModuleUrl);
		}else{
			ut.alert("Aucun module n'a t spcifi au lancement de l'application.");
			window.close();
		}
	}catch(e){
		ut.debug("deskplayer > initDesk : " + e);
	}
}

/** Chargement d'une session */
deskplayer.loadSession = function(pUrl){
	try{
		var vCanOpenSessionResult = this._sessionsMgr.canOpenSession(pUrl , null);
		if(vCanOpenSessionResult == 0){
			// fermeture de l'eventuelle ancienne session
			this.closeSession(false);
			// ouverture de la nouvelle session
			this.setCurrentSession(this._sessionsMgr.openSession(pUrl , null), pUrl);
			this._contentBrowser.setAttribute("src", this.xGetChromeFileUrl(cstBridgteBrowserUrl) + "?moduleUrl=" + this.getCurrentSession().getModuleUrl());//NOTE : oblig de passer en file pour des pbs de droit...
		}else if(vCanOpenSessionResult == Components.interfaces.scISessionsMgr.SC_ERR_SESSION_ALREADY_OPEN){
			ut.alert("Ce module est dja ouvert.");
			window.close();
		}else if(vCanOpenSessionResult == Components.interfaces.scISessionsMgr.SC_ERR_MODULE_NO_MANIFEST){
			ut.alert("Ce module n'est pas compatible SCORM 2004.");
			window.close();
		}else if(vCanOpenSessionResult == Components.interfaces.scISessionsMgr.SC_ERR_MODULE_NO_MAIN_FILE){
			ut.alert("Ce module n'est pas reconnu par l'application.\nLe fichier principal (index.html) n'est pas dfini.");
			window.close();
		}else if(vCanOpenSessionResult == Components.interfaces.scISessionsMgr.SC_ERR_MODULE_NO_DEFINED){
			ut.alert("Le module ne semble pas tre dfini correctement.\n'" + pUrl + "' est inconnu.");
			window.close();
		}else{
			ut.alert("Impossible d'ouvrir le module.");
			window.close();
		}
	}catch(e){
		ut.debug("deskplayer > loadSession : " + e);
	}
}

/** fermeture d'une session 
		pWithDeleteProductions : avec suppression des productions des apprenants pour cette session
*/
deskplayer.closeSession = function(pWithDeleteProductions){
	try{
		var vCurrentSession = this.getCurrentSession();
		this._contentBrowser.setAttribute("src","");
		if(vCurrentSession){
			var vKeyError = this._sessionsMgr.removeSession(vCurrentSession.getUid(), pWithDeleteProductions ? pWithDeleteProductions : false);
			this.setCurrentSession(null, null);
		}
	}catch(e){
		ut.debug("deskplayer > closeSession : " + e);
	}
}

/** currentSession
*/
deskplayer.getCurrentSession = function(){
	try{
		return this._currentSession;
	}catch(e){
		ut.debug("deskplayer > getCurrentSession : " + e);
		return null;
	}
}
deskplayer.setCurrentSession = function(pSession, pSessionDescriptionUrl){
	try{
		this._currentSession 	= pSession;
		this._currentSessionUrl = pSessionDescriptionUrl;
	}catch(e){
		ut.debug("deskplayer > getCurrentSession : " + e);
	}
}

/** Reinitialisation de la session en cours
*/
deskplayer.initSession = function(){
	try{
		var vCurrentSession = this.getCurrentSession();
		if(vCurrentSession){
			var vName = vCurrentSession.getName();
			var vUrl = vCurrentSession.getModuleUrl();
			if(ut.confirm("Etes vous sur de vouloir supprimer toutes les productions de la session '" + vName + "'?")){
				var vWinWait = ut.openWindowWait(null, "Rinitialisation", "Suppression des productions en cours");
				var vDeskPlayer = this;
				function removeSession(){
					var vSessionUrl = vDeskPlayer._currentSessionUrl;
					vDeskPlayer.closeSession(true);
					function reloadSession(pSessionUrl){
						vDeskPlayer.loadSession(pSessionUrl);
					}
					ut.closeWindowWait(vWinWait);
					window.setTimeout(reloadSession, 100, vSessionUrl);//NOTE : car pb d'asynchronie minime avec la suppression (bug xulRunner)
				}
				window.setTimeout(removeSession, 500);//NOTE : pour que la fenetre d'attente ait le temps de s'afficher
			}
		}
	}catch(e){
		ut.debug("deskplayer > initSession : " + e);
	}
}

/** Appele a la destruction de la fenetre */
deskplayer.destroyDesk = function(){
	try{
		
	}catch(e){
		ut.debug("deskplayer > destroyDesk : " + e);
	}
}

/** Appele a la fermeture de la fenetre */
deskplayer.canCloseDesk = function(){
	try{
		return true;
	}catch(e){
		ut.debug("deskplayer > canCloseDesk : " + e);
	}
}

/** Appele a la fermeture de la fenetre */
deskplayer.doCloseApp = function(){
	try{
		if(this.canCloseDesk()){
			this.destroyDesk();
			var vService = Components.classes["@mozilla.org/appshell/closeallwindows;1"].getService(Components.interfaces.nsICloseAllWindows);
   			vService.closeAll(true);
		}else{
			ut.alert("Fermeture de l'application impossible. Veuillez patienter...");
		}
	}catch(e){
		ut.debug("deskplayer > doCloseApp : " + e);
	}
}


/** Rafraichissement de la fenetre */
deskplayer.doRefreshWin = function(){
	try{
		if(this.canCloseDesk()) {
			this._contentBrowser.reload();
		}
	}catch(e){
		ut.debug("deskplayer > doRefreshWin : " + e);
	}
}

/** Ouverture des fenetre du menu **/
deskplayer.showAbout = function(){
	window.openDialog("chrome://scenariplayer/content/about/about.xul", "", "chrome, centerscreen, modal, resizable=false");
}
deskplayer.showConf = function(){
	var vSessionUrl = this._currentSessionUrl;
	this.closeSession();// on ferme la session en cours
	window.openDialog("chrome://scenariplayer/content/conf/conf.xul", "", "chrome, centerscreen, modal, resizable=false");
	this.loadSession(vSessionUrl);// on rouvre la dernire session
}
/** divers **/
deskplayer.xResolveModuleUrl = function(){
	try{
		var vCmdLinehandler = window.arguments ? window.arguments[0].QueryInterface(Components.interfaces.nsICommandLine) : null;
		var vModuleUrl = "";
		if(vCmdLinehandler && vCmdLinehandler.findFlag("module", true)>-1){
			vModuleUrl = vCmdLinehandler.resolveFile(vCmdLinehandler.handleFlagWithParam("module", true));// rsolution des chemuns relatifs
		}else{
			vModuleUrl = fBranch.getPrefType(prefScPModule)==32 ? fBranch.getCharPref(prefScPModule) : "";
		}
		// rsolution par rapport aus paths standards
		//	liste dfinie ici : http://lxr.mozilla.org/mozilla/source/xpcom/io/nsDirectoryServiceDefs.h
		// ex : CurWorkD(exe de lancement de l'appli), CurProcD (xulRunner)
		//ut.debug("CurWorkD :: "+vFolderService.get("CurWorkD", Components.interfaces.nsIFile).path);
		//ut.alert("CurProcD :: "+ut.listProperties(vFolderService.get("CurProcD", Components.interfaces.nsIFile)));
		var vFolderService = Components.classes["@mozilla.org/file/directory_service;1"].getService(Components.interfaces.nsIProperties);
		var vVarList = vModuleUrl.match(/\{([A-Za-z0-9]*)\}/g);
		for(var ii=0; ii<vVarList.length; ii++){
			try{
				var vResolvedVar = vFolderService.get(vVarList[ii].substring(1,vVarList[ii].length-1), Components.interfaces.nsIFile).path;
				vModuleUrl = vModuleUrl.replace(vVarList[ii], vResolvedVar);//.replace(/\\/g, '/')
			}catch(e){ut.debug("deskplayer > xResolveModuleUrl : Impossible de rsoudre la variable '" + vVarList[ii] + "'.");}
		}
		//return "C:/scenari_dev3/tests/SCENARIplayerCDROM_DEV/module/imsmanifest.xml";
		return vModuleUrl;
	}catch(e){
		ut.debug("deskplayer > xResolveModuleUrl : " + e);
		return null;
	}
}

deskplayer.xGetChromeFileUrl = function(pChrome){
	var ios =  Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
	var ch_ec = ios.newURI (pChrome, null, null);
	var chs =   Components.classes["@mozilla.org/chrome/chrome-registry;1"].getService(Components.interfaces.nsIChromeRegistry);
	var ch = chs.convertChromeURL(ch_ec);
	// cas particulier pour win (bug?). Solution donne sur les forums. A voir...
	var vPath = ((navigator.platform.substring(0,3) == "win") || (navigator.platform.substring(0,3) == "Win")) ? ch.path.replace(/\//g, '\\\\').substring(2) : ch.path;
	return "file://" + unescape(vPath);
}

